#if defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__) || defined(__DragonFly__) || defined(__APPLE__)
#if defined(__i386__)

/*
 * Use FreeBSD/NetBSD system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	mov	$SYS_exit, %eax
	jmp	_syscall

	.globl	__read
	.type	__read, @function
__read:
	mov	$SYS_read, %eax
	jmp	_syscall

	.globl	__write
	.type	__write, @function
__write:
	mov	$SYS_write, %eax
	jmp	_syscall

	.globl	__open
	.type	__open, @function
__open:
	mov	$SYS_open, %eax
	jmp	_syscall

	.globl	__close
	.type	__close, @function
__close:
	mov	$SYS_close, %eax
	jmp	_syscall

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	mov	$SYS_ioctl, %eax
	jmp	_syscall

_syscall:
	int	$0x80
	jnc	ret
err:	push	%eax
	call	_set_errno
	add	$0x4, %esp
ret:	ret
#endif
#endif
